!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #############################################################
      SUBROUTINE ALLOC_DIAG_SURF_ATM_n(HPROGRAM,KSW)
!     #############################################################
!
!!    AUTHOR
!!    ------
!!	V. Masson   *Meteo France*	
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004
!!      Modified    01/2006 : sea flux parameterization.
!!                  08/2009 : TIME_BUDGETC for all Tile
!       B. decharme 09/2012 : XQS_TILE not initialize
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_SURF_ATM_n,     ONLY : NSIZE_FULL, TTIME
USE MODD_DATA_COVER_PAR, ONLY : NTILESFC
USE MODD_SURF_PAR,       ONLY : XUNDEF
USE MODD_DIAG_SURF_ATM_n,ONLY : XRN_TILE, XH_TILE, XLE_TILE, XGFLUX_TILE,         &
                                XLEI_TILE, XRI_TILE, XCD_TILE, XCH_TILE, XCE_TILE,&
                                XT2M_TILE, XTS_TILE, XQ2M_TILE, XHU2M_TILE,       &
                                XZON10M_TILE, XMER10M_TILE, XQS_TILE,             &
                                XZ0_TILE, XZ0H_TILE, XT2M_MIN_TILE, XT2M_MAX_TILE,&
                                XSWD_TILE, XSWU_TILE, XSWBD_TILE, XSWBU_TILE,     &
                                XLWD_TILE,XLWU_TILE, XFMU_TILE, XFMV_TILE,        &
                                XAVG_RN, XAVG_H, XAVG_LE, XAVG_LEI,XAVG_GFLUX,    &
                                XAVG_LEIC, XAVG_RI, XAVG_CD, XAVG_CH, XAVG_CE,    &
                                XAVG_T2M, XAVG_TS, XAVG_Q2M, XAVG_HU2M,           &
                                XAVG_ZON10M, XAVG_MER10M, XAVG_SFCO2,             &
                                XAVG_T2M_MIN_ZS,XAVG_Q2M_MIN_ZS,XAVG_HU2M_MIN_ZS, &
                                XPS,XRHOA, XDIAG_TRAD, XDIAG_EMIS, XAVG_QS,       &
                                XAVG_Z0, XAVG_Z0H, XDIAG_UREF, XDIAG_ZREF,        &
                                XAVG_SWD, XAVG_SWU, XAVG_LWD, XAVG_LWU,           &
                                XAVG_SWBD, XAVG_SWBU, XAVG_FMU, XAVG_FMV,         &
                                XSSO_FMU, XSSO_FMV,                               &
                                TIME_BUDGETC, LSURF_BUDGETC, LRESET_BUDGETC,      &
                                LREAD_BUDGETC, XAVG_RNC, XAVG_HC, XAVG_LEC,       &
                                XAVG_GFLUXC, XAVG_SWDC, XAVG_SWUC, XAVG_LWDC,     &
                                XAVG_LWUC, XAVG_FMUC, XAVG_FMVC, XRNC_TILE,       &
                                XHC_TILE, XLEC_TILE, XGFLUXC_TILE, XSWDC_TILE,    &
                                XSWUC_TILE, XLWDC_TILE, XLWUC_TILE, XFMUC_TILE,   &
                                XFMVC_TILE, XAVG_T2M_MIN, XAVG_T2M_MAX,           &
                                XLEIC_TILE, XHU2M_MIN_TILE, XAVG_HU2M_MIN,        &
                                XHU2M_MAX_TILE, XAVG_HU2M_MAX, XWIND10M_TILE,     &
                                XAVG_WIND10M, XWIND10M_MAX_TILE, XAVG_WIND10M_MAX

!
USE MODI_READ_SURF
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
 CHARACTER(LEN=6),        INTENT(IN) :: HPROGRAM  ! program calling surf. schemes
INTEGER,                 INTENT(IN) :: KSW       ! number of short-wave spectral bands
!
!*       0.2   Declarations of local variables
!              -------------------------------
!
INTEGER           :: IRESP          ! IRESP  : return-code if a problem appears
 CHARACTER(LEN=12) :: YREC           ! Name of the article to be read
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!-------------------------------------------------------------------------------
!
!
! Initialization: Outputs to atmosphere over each tile:
!
IF (LHOOK) CALL DR_HOOK('ALLOC_DIAG_SURF_ATM_N',0,ZHOOK_HANDLE)
ALLOCATE(XRI_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XCD_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XCH_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XCE_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XRN_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XH_TILE      (NSIZE_FULL,NTILESFC))
ALLOCATE(XLE_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XLEI_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XGFLUX_TILE  (NSIZE_FULL,NTILESFC))
ALLOCATE(XT2M_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XTS_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XT2M_MIN_TILE(NSIZE_FULL,NTILESFC))
ALLOCATE(XT2M_MAX_TILE(NSIZE_FULL,NTILESFC))
ALLOCATE(XQ2M_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XHU2M_TILE   (NSIZE_FULL,NTILESFC))
ALLOCATE(XHU2M_MIN_TILE(NSIZE_FULL,NTILESFC))
ALLOCATE(XHU2M_MAX_TILE(NSIZE_FULL,NTILESFC))
ALLOCATE(XZON10M_TILE (NSIZE_FULL,NTILESFC))
ALLOCATE(XMER10M_TILE (NSIZE_FULL,NTILESFC))
ALLOCATE(XQS_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XZ0_TILE     (NSIZE_FULL,NTILESFC))
ALLOCATE(XZ0H_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XSWD_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XSWU_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XLWD_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XLWU_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XSWBD_TILE   (NSIZE_FULL,NTILESFC,KSW))
ALLOCATE(XSWBU_TILE   (NSIZE_FULL,NTILESFC,KSW))
ALLOCATE(XFMU_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XFMV_TILE    (NSIZE_FULL,NTILESFC))
ALLOCATE(XWIND10M_TILE(NSIZE_FULL,NTILESFC))
ALLOCATE(XWIND10M_MAX_TILE(NSIZE_FULL,NTILESFC))
!
XRI_TILE      = XUNDEF
XCD_TILE      = XUNDEF
XCH_TILE      = XUNDEF
XCE_TILE      = XUNDEF
XRN_TILE      = XUNDEF
XH_TILE       = XUNDEF
XLE_TILE      = XUNDEF
XLEI_TILE     = XUNDEF
XGFLUX_TILE   = XUNDEF
XT2M_TILE     = XUNDEF
XTS_TILE      = XUNDEF
XT2M_MIN_TILE = XUNDEF
XT2M_MAX_TILE = XUNDEF
XQ2M_TILE     = XUNDEF
XHU2M_TILE    = XUNDEF
XHU2M_MIN_TILE= XUNDEF
XHU2M_MAX_TILE= XUNDEF
XZON10M_TILE  = XUNDEF
XMER10M_TILE  = XUNDEF
XQS_TILE      = XUNDEF
XZ0_TILE      = XUNDEF
XZ0H_TILE     = XUNDEF
XSWD_TILE     = XUNDEF
XSWU_TILE     = XUNDEF
XLWD_TILE     = XUNDEF
XLWU_TILE     = XUNDEF
XSWBD_TILE    = XUNDEF
XSWBU_TILE    = XUNDEF
XFMU_TILE     = XUNDEF
XFMV_TILE     = XUNDEF
XWIND10M_TILE = XUNDEF
XWIND10M_MAX_TILE = XUNDEF
!
! Initialization: aggregated fields
!
ALLOCATE(XAVG_RI     (NSIZE_FULL))
ALLOCATE(XAVG_CD     (NSIZE_FULL))
ALLOCATE(XAVG_CH     (NSIZE_FULL))
ALLOCATE(XAVG_CE     (NSIZE_FULL))
ALLOCATE(XAVG_RN     (NSIZE_FULL))
ALLOCATE(XAVG_H      (NSIZE_FULL))
ALLOCATE(XAVG_LE     (NSIZE_FULL))
ALLOCATE(XAVG_LEI    (NSIZE_FULL))
ALLOCATE(XAVG_GFLUX  (NSIZE_FULL))
ALLOCATE(XAVG_T2M    (NSIZE_FULL))
ALLOCATE(XAVG_TS     (NSIZE_FULL))
ALLOCATE(XAVG_T2M_MIN(NSIZE_FULL))
ALLOCATE(XAVG_T2M_MAX(NSIZE_FULL))
ALLOCATE(XAVG_Q2M    (NSIZE_FULL))
ALLOCATE(XAVG_HU2M   (NSIZE_FULL))
ALLOCATE(XAVG_HU2M_MIN(NSIZE_FULL))
ALLOCATE(XAVG_HU2M_MAX(NSIZE_FULL))
ALLOCATE(XAVG_ZON10M (NSIZE_FULL))
ALLOCATE(XAVG_MER10M (NSIZE_FULL))
ALLOCATE(XAVG_SFCO2  (NSIZE_FULL))
ALLOCATE(XAVG_T2M_MIN_ZS    (NSIZE_FULL))
ALLOCATE(XAVG_Q2M_MIN_ZS    (NSIZE_FULL))
ALLOCATE(XAVG_HU2M_MIN_ZS   (NSIZE_FULL))
ALLOCATE(XPS                (NSIZE_FULL))
ALLOCATE(XRHOA              (NSIZE_FULL))
ALLOCATE(XAVG_QS     (NSIZE_FULL))
ALLOCATE(XAVG_Z0     (NSIZE_FULL))
ALLOCATE(XAVG_Z0H    (NSIZE_FULL))
ALLOCATE(XAVG_SWD    (NSIZE_FULL))
ALLOCATE(XAVG_SWU    (NSIZE_FULL))
ALLOCATE(XAVG_LWD    (NSIZE_FULL))
ALLOCATE(XAVG_LWU    (NSIZE_FULL))
ALLOCATE(XAVG_SWBD   (NSIZE_FULL,KSW))
ALLOCATE(XAVG_SWBU   (NSIZE_FULL,KSW))
ALLOCATE(XAVG_FMU    (NSIZE_FULL))
ALLOCATE(XAVG_FMV    (NSIZE_FULL))
ALLOCATE(XSSO_FMU    (NSIZE_FULL))
ALLOCATE(XSSO_FMV    (NSIZE_FULL))
ALLOCATE(XAVG_WIND10M(NSIZE_FULL))
ALLOCATE(XAVG_WIND10M_MAX(NSIZE_FULL))
!
ALLOCATE(XDIAG_UREF  (NSIZE_FULL))
ALLOCATE(XDIAG_ZREF  (NSIZE_FULL))
ALLOCATE(XDIAG_TRAD  (NSIZE_FULL))
ALLOCATE(XDIAG_EMIS  (NSIZE_FULL))
!
XAVG_RI      = XUNDEF
XAVG_CD      = XUNDEF
XAVG_CH      = XUNDEF
XAVG_CE      = XUNDEF
XAVG_RN      = XUNDEF
XAVG_H       = XUNDEF
XAVG_LE      = XUNDEF
XAVG_LEI     = XUNDEF
XAVG_GFLUX   = XUNDEF
XAVG_T2M     = XUNDEF
XAVG_TS      = XUNDEF
XAVG_T2M_MIN = XUNDEF
XAVG_T2M_MAX = XUNDEF
XAVG_Q2M     = XUNDEF
XAVG_HU2M    = XUNDEF
XAVG_HU2M_MIN= XUNDEF
XAVG_HU2M_MAX= XUNDEF
XAVG_ZON10M  = XUNDEF
XAVG_MER10M  = XUNDEF
XAVG_SFCO2   = XUNDEF
XAVG_T2M_MIN_ZS     = XUNDEF
XAVG_Q2M_MIN_ZS     = XUNDEF
XAVG_HU2M_MIN_ZS    = XUNDEF
XPS                 = XUNDEF
XRHOA               = XUNDEF
XAVG_QS      = XUNDEF
XAVG_Z0      = XUNDEF
XAVG_Z0H     = XUNDEF
XAVG_SWD     = XUNDEF
XAVG_SWU     = XUNDEF
XAVG_LWD     = XUNDEF
XAVG_LWU     = XUNDEF
XAVG_SWBD    = XUNDEF
XAVG_SWBU    = XUNDEF
XAVG_FMU     = XUNDEF
XAVG_FMV     = XUNDEF
XSSO_FMU     = XUNDEF
XSSO_FMV     = XUNDEF
XAVG_WIND10M = XUNDEF
XAVG_WIND10M_MAX = XUNDEF
!
XDIAG_UREF   = XUNDEF
XDIAG_ZREF   = XUNDEF
XDIAG_TRAD   = XUNDEF
XDIAG_EMIS   = XUNDEF
!
IF (LSURF_BUDGETC) THEN
!
  ALLOCATE(XRNC_TILE     (NSIZE_FULL,NTILESFC))
  ALLOCATE(XHC_TILE      (NSIZE_FULL,NTILESFC))
  ALLOCATE(XLEC_TILE     (NSIZE_FULL,NTILESFC))
  ALLOCATE(XLEIC_TILE    (NSIZE_FULL,NTILESFC))
  ALLOCATE(XGFLUXC_TILE  (NSIZE_FULL,NTILESFC))
  ALLOCATE(XSWDC_TILE    (NSIZE_FULL,NTILESFC))
  ALLOCATE(XSWUC_TILE    (NSIZE_FULL,NTILESFC))
  ALLOCATE(XLWDC_TILE    (NSIZE_FULL,NTILESFC))
  ALLOCATE(XLWUC_TILE    (NSIZE_FULL,NTILESFC))
  ALLOCATE(XFMUC_TILE    (NSIZE_FULL,NTILESFC))
  ALLOCATE(XFMVC_TILE    (NSIZE_FULL,NTILESFC))
!
  XRNC_TILE      = XUNDEF
  XHC_TILE       = XUNDEF
  XLEC_TILE      = XUNDEF
  XLEIC_TILE     = XUNDEF
  XGFLUXC_TILE   = XUNDEF
  XSWDC_TILE     = XUNDEF
  XSWUC_TILE     = XUNDEF
  XLWDC_TILE     = XUNDEF
  XLWUC_TILE     = XUNDEF
  XFMUC_TILE     = XUNDEF
  XFMVC_TILE     = XUNDEF
!
  ALLOCATE(XAVG_RNC     (NSIZE_FULL))
  ALLOCATE(XAVG_HC      (NSIZE_FULL))
  ALLOCATE(XAVG_LEC     (NSIZE_FULL))
  ALLOCATE(XAVG_LEIC    (NSIZE_FULL))
  ALLOCATE(XAVG_GFLUXC  (NSIZE_FULL))
  ALLOCATE(XAVG_SWDC    (NSIZE_FULL))
  ALLOCATE(XAVG_SWUC    (NSIZE_FULL))
  ALLOCATE(XAVG_LWDC    (NSIZE_FULL))
  ALLOCATE(XAVG_LWUC    (NSIZE_FULL))
  ALLOCATE(XAVG_FMUC    (NSIZE_FULL))
  ALLOCATE(XAVG_FMVC    (NSIZE_FULL))
!
  YREC='BUDC'
  CALL READ_SURF(HPROGRAM,YREC,LREAD_BUDGETC,IRESP)
!
  IF (.NOT. LREAD_BUDGETC) THEN
      TIME_BUDGETC = TTIME
      XAVG_RNC    = 0.0
      XAVG_HC     = 0.0
      XAVG_LEC    = 0.0
      XAVG_LEIC   = 0.0
      XAVG_GFLUXC = 0.0
      XAVG_SWDC   = 0.0
      XAVG_SWUC   = 0.0
      XAVG_LWDC   = 0.0
      XAVG_LWUC   = 0.0
      XAVG_FMUC   = 0.0
      XAVG_FMVC   = 0.0      
  ELSEIF (LREAD_BUDGETC.AND.LRESET_BUDGETC) THEN
      TIME_BUDGETC = TTIME
      XAVG_RNC    = 0.0
      XAVG_HC     = 0.0
      XAVG_LEC    = 0.0
      XAVG_LEIC   = 0.0
      XAVG_GFLUXC = 0.0
      XAVG_SWDC   = 0.0
      XAVG_SWUC   = 0.0
      XAVG_LWDC   = 0.0
      XAVG_LWUC   = 0.0
      XAVG_FMUC   = 0.0
      XAVG_FMVC   = 0.0       
  ELSE
      YREC='TBUDC'
      CALL READ_SURF(HPROGRAM,YREC,TIME_BUDGETC,IRESP)
     YREC='RNC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_RNC,IRESP)
     YREC='HC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_HC ,IRESP)
     YREC='LEC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_LEC,IRESP)
     YREC='LEIC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_LEIC,IRESP)     
     YREC='GFLUXC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_GFLUXC ,IRESP)
     YREC='SWDC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_SWDC,IRESP)
     YREC='SWUC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_SWUC,IRESP)
     YREC='LWDC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_LWDC,IRESP)
     YREC='LWUC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_LWUC,IRESP)
     YREC='FMUC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_FMUC,IRESP)
     YREC='FMVC'
     CALL READ_SURF(HPROGRAM,YREC,XAVG_FMVC,IRESP)      
  ENDIF
!
ELSE
!
  ALLOCATE(XRNC_TILE     (0,0))
  ALLOCATE(XHC_TILE      (0,0))
  ALLOCATE(XLEC_TILE     (0,0))
  ALLOCATE(XLEIC_TILE    (0,0))
  ALLOCATE(XGFLUXC_TILE  (0,0))
  ALLOCATE(XSWDC_TILE    (0,0))
  ALLOCATE(XSWUC_TILE    (0,0))
  ALLOCATE(XLWDC_TILE    (0,0))
  ALLOCATE(XLWUC_TILE    (0,0))
  ALLOCATE(XFMUC_TILE    (0,0))
  ALLOCATE(XFMVC_TILE    (0,0))
!
  ALLOCATE(XAVG_RNC     (0))
  ALLOCATE(XAVG_HC      (0))
  ALLOCATE(XAVG_LEC     (0))
  ALLOCATE(XAVG_LEIC    (0))
  ALLOCATE(XAVG_GFLUXC  (0))
  ALLOCATE(XAVG_SWDC    (0))
  ALLOCATE(XAVG_SWUC    (0))
  ALLOCATE(XAVG_LWDC    (0))
  ALLOCATE(XAVG_LWUC    (0))
  ALLOCATE(XAVG_FMUC    (0))
  ALLOCATE(XAVG_FMVC    (0))
!
ENDIF
IF (LHOOK) CALL DR_HOOK('ALLOC_DIAG_SURF_ATM_N',1,ZHOOK_HANDLE)
!
!-------------------------------------------------------------------------------
!
END SUBROUTINE ALLOC_DIAG_SURF_ATM_n
