!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     ##################
      MODULE MODN_WATFLUX_n
!     ##################
!
!!****  *MODN_WATFLUX_n* - declaration of namelist NAM_WATFLUXn
!!
!!    PURPOSE
!!    -------
!       The purpose of this module is to specify  the namelist NAM_WATFLUXn
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!       
!!    AUTHOR
!!    ------
!!	V. Masson    *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004                    
!!      Modified    08/2009 by B. Decharme : LSURF_BUDGETC for all tiles
!-------------------------------------------------------------------------------
!
!*       0.   DECLARATIONS
!             ------------
!
USE MODD_WATFLUX_n, ONLY: &
           XTSTEP_n => XTSTEP, &
           XOUT_TSTEP_n => XOUT_TSTEP, &
           CWAT_ALB_n=>CWAT_ALB, &
           CINTERPOL_TS_n => CINTERPOL_TS  
!
USE MODD_DIAG_WATFLUX_n, ONLY: &
           XDIAG_TSTEP_n => XDIAG_TSTEP, &
           N2M_n => N2M, &
           L2M_MIN_ZS_n => L2M_MIN_ZS, &
           LSURF_BUDGET_n => LSURF_BUDGET, &
           LRAD_BUDGET_n => LRAD_BUDGET, &
           LSURF_BUDGETC_n => LSURF_BUDGETC, &
           LRESET_BUDGETC_n => LRESET_BUDGETC,          &
           LCOEF_n => LCOEF, &
           LSURF_VARS_n => LSURF_VARS  
         
USE MODD_CH_WATFLUX_n, ONLY: &
           CCH_DRY_DEP_n => CCH_DRY_DEP  
!
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
 CHARACTER(LEN=4)  :: CWAT_ALB
REAL     :: XTSTEP
REAL     :: XOUT_TSTEP
REAL     :: XDIAG_TSTEP
INTEGER  :: N2M
LOGICAL  :: L2M_MIN_ZS
LOGICAL  :: LSURF_BUDGET
LOGICAL  :: LRAD_BUDGET
LOGICAL  :: LSURF_BUDGETC
LOGICAL  :: LRESET_BUDGETC
LOGICAL  :: LCOEF
LOGICAL  :: LSURF_VARS
 CHARACTER(LEN=6)  :: CCH_DRY_DEP
 CHARACTER(LEN=6)  :: CINTERPOL_TS
!
NAMELIST/NAM_WATFLUXn/CWAT_ALB,CINTERPOL_TS
NAMELIST/NAM_DIAG_SURFn/N2M,L2M_MIN_ZS,LSURF_BUDGET,LRAD_BUDGET, &
                          LSURF_BUDGETC,LRESET_BUDGETC,LCOEF,LSURF_VARS  
NAMELIST/NAM_CH_WATFLUXn/CCH_DRY_DEP
!
CONTAINS
!
SUBROUTINE INIT_NAM_WATFLUXn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:INIT_NAM_WATFLUXN',0,ZHOOK_HANDLE)
  XTSTEP = XTSTEP_n
  XOUT_TSTEP = XOUT_TSTEP_n  
  CWAT_ALB = CWAT_ALB_n
  CINTERPOL_TS = CINTERPOL_TS_n
IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:INIT_NAM_WATFLUXN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_WATFLUXn
!
SUBROUTINE UPDATE_NAM_WATFLUXn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:UPDATE_NAM_WATFLUXN',0,ZHOOK_HANDLE)
  XTSTEP_n = XTSTEP
  XOUT_TSTEP_n = XOUT_TSTEP    
  CWAT_ALB_n = CWAT_ALB
  CINTERPOL_TS_n = CINTERPOL_TS
IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:UPDATE_NAM_WATFLUXN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_WATFLUXn
!
SUBROUTINE INIT_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:INIT_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP = XDIAG_TSTEP_n  
  N2M = N2M_n
  L2M_MIN_ZS = L2M_MIN_ZS_n
  LSURF_BUDGET = LSURF_BUDGET_n
  LRAD_BUDGET = LRAD_BUDGET_n
  LSURF_BUDGETC = LSURF_BUDGETC_n
  LRESET_BUDGETC = LRESET_BUDGETC_n  
  LCOEF = LCOEF_n
  LSURF_VARS = LSURF_VARS_n
IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:INIT_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_DIAG_SURFn

SUBROUTINE UPDATE_NAM_DIAG_SURFn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:UPDATE_NAM_DIAG_SURFN',0,ZHOOK_HANDLE)
  XDIAG_TSTEP_n = XDIAG_TSTEP  
  N2M_n = N2M
  L2M_MIN_ZS_n = L2M_MIN_ZS
  LSURF_BUDGET_n = LSURF_BUDGET
  LRAD_BUDGET_n = LRAD_BUDGET 
  LSURF_BUDGETC_n = LSURF_BUDGETC
  LRESET_BUDGETC_n = LRESET_BUDGETC  
  LCOEF_n = LCOEF
  LSURF_VARS_n = LSURF_VARS
IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:UPDATE_NAM_DIAG_SURFN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_DIAG_SURFn

SUBROUTINE INIT_NAM_CH_WATFLUXn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:INIT_NAM_CH_WATFLUXN',0,ZHOOK_HANDLE)
  CCH_DRY_DEP = CCH_DRY_DEP_n
IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:INIT_NAM_CH_WATFLUXN',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_NAM_CH_WATFLUXn

SUBROUTINE UPDATE_NAM_CH_WATFLUXn

  REAL(KIND=JPRB) :: ZHOOK_HANDLE

  IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:UPDATE_NAM_CH_WATFLUXN',0,ZHOOK_HANDLE)
  CCH_DRY_DEP_n = CCH_DRY_DEP
IF (LHOOK) CALL DR_HOOK('MODN_WATFLUX_N:UPDATE_NAM_CH_WATFLUXN',1,ZHOOK_HANDLE)
END SUBROUTINE UPDATE_NAM_CH_WATFLUXn


END MODULE MODN_WATFLUX_n
